#include <gtk/gtk.h>
#include <stdio.h>
#include <fcntl.h>
#include "common.h"
#include "icon.h"
#include "createwidget.h"

extern clwindow winMain;

/*
	ޥɼ¹
*/
int
ExecCmd( char **cmd )
{
	int		pipe_out[ 2 ],pipe_err[ 2 ];
	int		pid;
	char	buff;
	int		rtnErrCnt,i,j;
	int		fd;

	if( pipe( pipe_out ) < 0 ) {
		return -1;
	}

	if( pipe( pipe_err ) < 0 ) {
		close( pipe_out[ R ] );
		close( pipe_out[ W ] );
		return -1;
	}

	if( ( pid = fork() ) < 0 ) {
		close( pipe_out[ R ] );
		close( pipe_out[ W ] );
		close( pipe_err[ R ] );
		close( pipe_err[ W ] );
		return -1;
	}
	else if( pid > 0 ) {
		close( pipe_out[ W ] );
		close( pipe_err[ W ] );

		wait( NULL );

		unlink( NAME_EXEC_STDERR );
		fd = open( NAME_EXEC_STDERR,O_RDWR | O_CREAT | O_TRUNC,0600 );
		while( read( pipe_err[ R ],&buff,1) > 0 ) {
			write( fd,&buff,1 );
		}
		close(fd);

		unlink( NAME_EXEC_STDOUT );
		fd = open( NAME_EXEC_STDOUT,O_RDWR | O_CREAT | O_TRUNC,0600 );
		while( read( pipe_out[ R ],&buff,1) > 0 ) {
			write( fd,&buff,1 );
		}
		close(fd);

		close( pipe_err[ R ] );
		close( pipe_out[ R ] );
	}
	else if( pid == 0 ){
		close( pipe_out[ R ] );
		dup2( pipe_out[ W ],1 );
		close( pipe_out[ W ] );

		close( pipe_err[ R ] );
		dup2( pipe_err[ W ],2 );
		close( pipe_err[ W ] );

		if( execvp(*cmd,cmd ) == -1 ){
			_exit( 127 );
		}
	}

	return 0;
}

/*
	ޥɼ¹Ըνϥե뻲
*/
int
ReadExecFile( int kind,char **buff_out )
{
	int 	fd;
	int 	filecnt;
	char	filename[ 30 ];
	int 	i = 0;

	switch( kind ) {
	case EXEOUT:
		strcpy( filename,NAME_EXEC_STDOUT );
		break;
	case EXEERR:
		strcpy( filename,NAME_EXEC_STDERR );
		break;
	}

	fd = open( filename,O_RDONLY );
	filecnt = ( int )lseek( fd,0,SEEK_END );
	*buff_out = ( char * )malloc( filecnt + 1 );
	lseek( fd,0,SEEK_SET );
	while( read( fd,*buff_out,1 ) > 0 ) {
		i++;
		( *buff_out )++;
	}
	**buff_out = 0x00;
	*buff_out -= i;
	close( fd );
	unlink( filename );

	return i;
}

/*
	ư̥롼(Fdd)
*/
void
SetTopFdd()
{
	GtkWidget *xmpFdd;
	char *cmdCkmount[] = { CMDSUDO,CMDMOUNT,NULL };
	char *rtnMsg;
	char *pmsg,*pon;
	char *stat,*mp,*mode;
	char buffMount[ 256 ];
	char buffMp[ 256 ];
	int  visible;
	int  i,rtnCnt;
	char *buff_out,*buff_err;

	if( ExecCmd( cmdCkmount ) != -1 ) {
		rtnCnt = ReadExecFile( EXEOUT,&buff_out );
		if( pmsg = (char *)strstr( buff_out,NAME_DEVICE_FDD ) ) {
			visible = TRUE;
			stat    = MSG_MOUNT;
			i = 0;
			while( *pmsg++ != ')' ) {
				buffMount[ i ] = *pmsg;
				i++;
			}

			if( strstr( buffMount,"rw" ) ) {
				mode = MSG_RW;
			} else {
				mode = MSG_RONLY;
			}

			pon = ( char * )strstr( buffMount,"on" );
			pon += 3;
			i = 0;
			while( *pon != ' ' ) {
				buffMp[ i ] = *pon;
				pon++;
				i++;
			}
			buffMp[ i ] = 0x00;
			mp = buffMp;
	
		} else {
			visible = FALSE;
			stat = MSG_NOMOUNT;
			mp   = "";
			mode = "";
		}
		free( buff_out );
	} else {
			return;
	}

	gtk_entry_set_text( GTK_ENTRY( GET_OBJECT( winMain.window,NAME_TOP_ETYFDD_STAT ) ),stat );
	gtk_entry_set_text( GTK_ENTRY( GET_OBJECT( winMain.window,NAME_TOP_ETYFDD_MP ) ),mp );
	gtk_entry_set_text( GTK_ENTRY( GET_OBJECT( winMain.window,NAME_TOP_ETYFDD_MODE ) ),mode );
	SetTopIcon( ICON_FDD,visible );

	return;
}

/*
	ư̥ɽ
*/
void
SetTopIcon( int kind,int visible )
{
	GtkWidget	*widget;
	Position	pos;
	char		fixname[ 10 ];
	char		**pxpm;

	switch( kind ) {
	case ICON_FDD:
		widget = winMain.xmpFdd;
		pos.x  = NUM_TOP_XMPFDD_X;
		pos.y  = NUM_TOP_XMPFDD_Y;
		if( visible ) {
			pxpm   = fdin_xpm;
		} else {
			pxpm   = fdout_xpm;
		}
		strcpy( fixname,NAME_TOP_FIXFDD );
		break;
	case ICON_PCC0:
		widget = winMain.xmpPcc0;
		pos.x  = NUM_TOP_XMPPCC0_X;
		pos.y  = NUM_TOP_XMPPCC0_Y;
		if( visible ) {
			pxpm   = pcin_xpm;
		} else {
			pxpm   = pcout_xpm;
		}
		strcpy( fixname,NAME_TOP_FIXPCC );
		break;
	case ICON_PCC1:
		widget = winMain.xmpPcc1;
		pos.x  = NUM_TOP_XMPPCC1_X;
		pos.y  = NUM_TOP_XMPPCC1_Y;
		if( visible ) {
			pxpm   = pcin_xpm;
		} else {
			pxpm   = pcout_xpm;
		}
		strcpy( fixname,NAME_TOP_FIXPCC );
		break;
	}

	if( widget ) {
		gtk_widget_destroy( widget );
	}

	widget = CreatePixmap( winMain.window,pxpm );
	gtk_fixed_put( GTK_FIXED( GET_OBJECT( winMain.window,fixname ) ),
				   widget,
				   pos.x,pos.y );
	gtk_widget_set_uposition( widget,
							 pos.x,pos.y );
	gtk_widget_set_usize ( widget,
						   NUM_TOP_XMP_WIDTH,NUM_TOP_XMP_HEIGHT );
	gtk_misc_set_alignment ( GTK_MISC( widget ),7.45058e-09,7.45058e-09 );
	gtk_widget_show( widget );
}

/*
	ư̥롼(Pcc)
*/
void
SetTopPcc( int SocketNo )
{
	char *cmdCkmount[] = { CMDSUDO,CMDMOUNT,NULL };
	char *pmsg;
	char *buff_out,*buff_err;
	char buffMount[ 256 ],mpoint[ 16 ];
	char setstat[ 16 ],setkind[ 16 ],setmp[ 16 ],setmode[ 16 ];
	char stat[ 128 ],kind[ 128 ],mp[ 128 ],mode[ 128 ];
	int  icon,visible,i;

	switch( SocketNo ) {
	case SOCKET0:
		strcpy( setstat,NAME_TOP_ETYPCC_STAT0);
		strcpy( setkind,NAME_TOP_ETYPCC_KIND0 );
		strcpy( setmp,NAME_TOP_ETYPCC_MP0 );
		strcpy( setmode,NAME_TOP_ETYPCC_MODE0 );
		strcpy( mpoint,STR_MPS0 );
		icon = ICON_PCC0;
		break;
	case SOCKET1:
		strcpy( setstat,NAME_TOP_ETYPCC_STAT1);
		strcpy( setkind,NAME_TOP_ETYPCC_KIND1 );
		strcpy( setmp,NAME_TOP_ETYPCC_MP1 );
		strcpy( setmode,NAME_TOP_ETYPCC_MODE1 );
		strcpy( mpoint,STR_MPS1 );
		icon = ICON_PCC1;
		break;
	}

	strcpy( mp,"" );
	strcpy( mode,"" );
	switch( GetSocketInfo( SocketNo ) ) {
	case FUNC_IDE:
		strcpy( stat,STR_INSERT );
		strcpy( kind,STR_IDE );
		visible = TRUE;

		if( ExecCmd( cmdCkmount ) != -1 ) {
			ReadExecFile( EXEOUT,&buff_out );
			pmsg = ( char * )strstr( buff_out,mpoint );
			if( pmsg != NULL ){
				strcpy( mp,mpoint );
				while( *pmsg++ != 0x28 )
				i=0;
				while( *pmsg != 0x29 ) {
					buffMount[ i++ ] = *pmsg;
					pmsg++;
				}
	
				if( strstr( buffMount,"rw" ) ) {
					strcpy( mode,MSG_RW );
				} else {
					strcpy( mode,MSG_RONLY );
				}
			}
			free( buff_out );
		} else {
			return;
		}

		break;
	case FUNC_LAN:
		strcpy( stat,STR_INSERT );
		strcpy( kind,STR_LAN );
		visible = TRUE;
		break;
	case FUNC_OTHER:
		strcpy( stat,STR_INSERT );
		strcpy( kind,STR_OTHER );
		visible = TRUE;
		break;
	case FUNC_NONE:
	case FUNC_NOCARD:
		strcpy( stat,STR_NOTINSERT );
		strcpy( kind,"" );
		visible = FALSE;
		break;
	}

	gtk_entry_set_text( GTK_ENTRY( GET_OBJECT( winMain.window,setstat ) ),stat );
	gtk_entry_set_text( GTK_ENTRY( GET_OBJECT( winMain.window,setkind ) ),kind );
	gtk_entry_set_text( GTK_ENTRY( GET_OBJECT( winMain.window,setmp ) ),mp );
	gtk_entry_set_text( GTK_ENTRY( GET_OBJECT( winMain.window,setmode ) ),mode );
	SetTopIcon( icon,visible );

	return;
}

/*
	
*/
int
GetSocketInfo( int SocketNo ) {
	char *cmdIdent[]  = { CMDSUDO,CMDCARDCTL,"ident",NULL,NULL };
	char *cmdStatus[] = { CMDSUDO,CMDCARDCTL,"status",NULL,NULL };
	char buffCardctl[ 16 ];
	char *pmsg;
	char *buff_out,*buff_err;
	int  rtnCd,i;

	switch( SocketNo ) {
	case 0:
		cmdStatus[ 3 ] = "0";
		cmdIdent[ 3 ]  = "0";
		break;
	case 1:
		cmdStatus[ 3 ] = "1";
		cmdIdent[ 3 ]  = "1";
		break;
	}

	if( ExecCmd( cmdStatus ) != -1 ) {
		if( ReadExecFile( EXEERR,&buff_err ) ) {
			free( buff_err );
			return -1;
		}
		free( buff_err );

		ReadExecFile( EXEOUT,&buff_out );
		if( strstr( buff_out,STR_NOCARD ) ) {
			free( buff_out );
			return FUNC_NOCARD;
		}
		free( buff_out );
	} else {
		return -1;
	}

	if( ExecCmd( cmdIdent ) != -1 ) {
		ReadExecFile( EXEOUT,&buff_out );
		if( strstr( buff_out,STR_NOPRODUCT ) ) {
			free( buff_out );
			return FUNC_OTHER;
		}
	} else {
		return -1;
	}

	i = 0;
	pmsg = ( char * )strstr( buff_out,STR_FUNCTION );
	if( pmsg == NULL ) {
		free( buff_out );
		return -1;
	}

	pmsg += 9;
	while( *pmsg != 0x28 ) {
		buffCardctl[ i ] = *pmsg;
		pmsg++;
		i++;
	}
	free( buff_out );

	switch( atoi( buffCardctl ) ) {
	case 4:
		rtnCd = FUNC_IDE;
		break;
	case 6:
		rtnCd = FUNC_LAN;
		break;
	default:
		rtnCd = FUNC_OTHER;
		break;
	}

	return rtnCd;
}

int
GetDeviceName( int SocketNo,char **Device ) {
	char *cmdCatstab[] = { CMDCAT,FILE_STAB,NULL };
	char *buff_out,*buff_err;
	char *pSocket,*pDevice;
	char *pbuff_out;
	char buff_S0[ BUFSIZ ],buff_S1[ BUFSIZ ];
	int  rtnCnt = 0,c1 = 0,c2 = 0;
	char *ppoint;
	int  i = 0;
	if( ExecCmd( cmdCatstab ) != -1 ) {
		rtnCnt = ReadExecFile( EXEOUT,&buff_out );
		pbuff_out = buff_out;
		ppoint = ( char * )strstr( pbuff_out,STR_SOCKET1 );
		while( pbuff_out != ppoint ) buff_S0[ c1++ ] = *pbuff_out++;
		buff_S0[ c1 ] = 0x00;

		rtnCnt -= c1;
		while( rtnCnt-- ) buff_S1[ c2++ ] = *ppoint++;
		buff_S1[ c2 ] = 0x00;
		free( buff_out );

		switch( SocketNo ) {
		case SOCKET0:
			pSocket = buff_S0;
			break;
		case SOCKET1:
			pSocket = buff_S1;
			break;
		}
		*Device = ( char * )malloc( 9 );
		if( strstr( pSocket,STR_EMPTY ) ) {
			return -1;
		}
		if( ( pDevice = ( char * )strstr( pSocket,"hd" ) ) ) {
			**Device = 0x2f;
			( *Device )++;
			**Device = 0x64;
			( *Device )++;
			**Device = 0x65;
			( *Device )++;
			**Device = 0x76;
			( *Device )++;
			**Device = 0x2f;
			( *Device )++;
			while( i < 3 ) {
				**Device = *pDevice++;
				( *Device )++;
				i++;
			}
			**Device = 0x00;
			*Device -= ( i + 5 );
		} else {
			return 0;
		}
	} else {
		return -1;
	}

	return 0;
}

int
SelectHelpByLocale(unsigned char *ucpFileName,HELP_LOC_UDT *help_loc)
{
	struct stat st;					/*̎پ*/
	off_t  FileSize;				/* َ̎ */
	char *cpRtn;
	int iDefaultFileFlag;
	int iRtnCd;

	/**/
	iDefaultFileFlag = 1;

	cpRtn = getenv(STR_ENV);						/*Ķѿ*/
	if(NULL == cpRtn) {								/**/
		return -1;
	} else if(0 == strcmp(cpRtn,STR_LOCALEJA)) {	/*ܸ*/
		snprintf(ucpFileName,1024-1,"%s",help_loc->loc_ja);
		iDefaultFileFlag = 0;

		iRtnCd = GetFileSize(ucpFileName);
		if(-1 == iRtnCd)
			iDefaultFileFlag = 1;

	}

	if(1 == iDefaultFileFlag) {						/*Îގَ̎*/
		snprintf(ucpFileName,1024-1,"%s",help_loc->loc_default);

		iRtnCd = GetFileSize(ucpFileName);
		if(-1 == iRtnCd)
			return -1;

	}

	return 0;
}

int
GetFileSize(const unsigned char *ucpFileName)
{
	struct stat st;					/*̎پ*/
	off_t  FileSize;				/* َ̎ */
	int iRtnCd;

	iRtnCd = stat(ucpFileName,&st);
	if(-1 == iRtnCd) {
		return -1;
	} else {
		FileSize = st.st_size;
		if(1 > FileSize) {
			return -1;
		}
	}

	return 0;
}
