#include <gtk/gtk.h>
#include "common.h"
#include "createwidget.h"

/*
	fixed box
*/
GtkWidget *
CreateFixed( GtkWidget *winBase,char* name )
{
	GtkWidget	*fixed;

	fixed = gtk_fixed_new();
	gtk_object_set_data( GTK_OBJECT( winBase ),
						 name,
						 fixed );
	gtk_widget_show( fixed );

	return fixed;
}

/*
	frmae
*/
GtkWidget *
CreateFrame( GtkWidget *winBase,char *name,char* label,Scale *sca,Position *pos,int shadow )
{
	GtkWidget	*frame;
	
	frame = gtk_frame_new( label );
	gtk_object_set_data( GTK_OBJECT( winBase ),
						 name,
						 frame );
	gtk_widget_set_usize( frame,
						  sca->width,
						  sca->height );
	gtk_widget_set_uposition( frame,
							  pos->x,pos->y);
	gtk_frame_set_shadow_type( GTK_FRAME( frame ),
							   shadow );

	gtk_widget_show( frame );

	return frame;
}

/*
	button
*/
GtkWidget*
CreateButton( GtkWidget *winBase,char *name,char *label,Scale *sca,Position *pos,int sens )
{
	GtkWidget	*button;
	
	button = gtk_button_new_with_label( label );
	gtk_object_set_data( GTK_OBJECT( winBase ),
						 name,
						 button );
	gtk_widget_set_usize( button,
						  sca->width,
						  sca->height );
	gtk_widget_set_sensitive( button,
							  sens );
	gtk_widget_set_uposition( button,
							  pos->x,pos->y );
	gtk_widget_show( button );

	return button;
}

/*
	label
*/
GtkWidget*
CreateLabel( GtkWidget *winBase,char *name,char *label,Scale *sca,Position *pos,int justify )
{
	GtkWidget	*lab;
	
	lab = gtk_label_new( label );
	gtk_object_set_data( GTK_OBJECT( winBase ),
						 name,
						 lab );
	gtk_widget_set_usize( lab,
						  sca->width,
						  sca->height );
	gtk_label_set_justify( GTK_LABEL( lab ),
						   justify );
	gtk_label_set_line_wrap( GTK_LABEL( lab ),
							 TRUE );
	gtk_widget_set_uposition( lab,
							  pos->x,pos->y );
	gtk_misc_set_alignment( GTK_MISC( lab ),
							7.45058e-09,0.5 );
	gtk_widget_show( lab );

	return lab;
}

/*
	entry box
*/
GtkWidget*
CreateEntry( GtkWidget *winBase,char *name,char* label,Scale* sca,Position* pos )
{
	GtkWidget	*entry;
	
	entry = gtk_entry_new();
	gtk_object_set_data( GTK_OBJECT( winBase ),
						 name,
						 entry );
	gtk_widget_set_usize( entry,
						  sca->width,
						  sca->height );
	gtk_widget_set_uposition( entry,
							  pos->x,pos->y);
	GTK_WIDGET_UNSET_FLAGS( entry,
							GTK_CAN_FOCUS );
	gtk_entry_set_editable( GTK_ENTRY( entry ),
							FALSE );
	gtk_widget_show( entry );

	return entry;
}

/*
	pixmap
*/
GtkWidget*
CreatePixmap(GtkWidget *widget,gchar **xpm_data)
{
  GdkColormap *colormap;
  GdkPixmap *gdkpixmap;
  GdkBitmap *mask;
  GtkWidget *pixmap;

  colormap = gtk_widget_get_colormap (widget);
  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL, colormap, &mask,
                                                   NULL, ( gchar **) xpm_data );
  pixmap = gtk_pixmap_new (gdkpixmap, mask);
  gdk_pixmap_unref (gdkpixmap);
  gdk_bitmap_unref (mask);

  return pixmap;
}
