#include <gtk/gtk.h>

#define PACKAGE   "pctool"
#define LOCALEDIR "/usr/local/share/locale/"
#define _(text)   gettext(text)

/*  */
#define NUM_BTN_BASIC_WIDTH		68
#define NUM_BTN_BASIC_HEIGHT	24
#define NUM_BTN_WIDE_WIDTH		60
#define NUM_BTN_WIDE_HEIGHT		32
#define NUM_RBTN_BASIC_WIDTH	128
#define NUM_RBTN_BASIC_HEIGHT	26
#define NUM_RBTN_WIDE_WIDTH		184
#define NUM_RBTN_WIDE_HEIGHT	26
#define NUM_LBL_BASIC_WIDTH		120
#define NUM_LBL_BASIC_HEIGHT	26
#define NUM_ETY_BASIC_WIDTH		168
#define NUM_ETY_BASIC_HEIGHT	26

/* ʸ */
#define STR_NOCARD				"no card"
#define STR_NOPRODUCT			"no product"
#define STR_FUNCTION			"function:"
#define STR_SOCKET0				"Socket 0"
#define STR_SOCKET1				"Socket 1"
#define	STR_NODEV				"No such device"
#define	ERR_DIFFERFS			"Currently, only 2 FATs are supported, not"
#define	STR_USEDEV				"Device or resource busy"
#define	STR_NOTCONFIGURED		"Device not configured"
#define	STR_EMPTY				"empty"
#define	STR_OUT_FDISK			"error"

/* ɽʸ */
#define STR_HELP				_("Help")
#define STR_TOOL				_("Tool")
#define STR_END					_("Exit")
#define STR_FLOPPY				_("Floppy")
#define STR_CONFIRM				_("CHK Stat.")
#define STR_AFS					_("A.M. Restart")
#define STR_PCC					_("PC Card")
#define STR_USESTART			_("Start")
#define STR_USESTOP				_("Stop")
#define STR_STAT				_("Status")
#define STR_MP					_("Mount Point")
#define STR_MODE				_("R/W Mode")
#define STR_KIND				_("Card Category")
#define STR_PCCS0				_("Slot0(Lower)")
#define STR_PCCS1				_("Slot1(Upper)")
#define STR_RETURN				_("Return")
#define STR_FCK					_("fsck")
#define STR_FMT					_("format")
#define STR_EXE					_("Run")
#define STR_PCSOCKET0			_("PC Card Slot0(Lower)")
#define STR_PCSOCKET1			_("PC Card Slot1(Upper)")
#define STR_INSERT				_("Recognize")
#define STR_NOTINSERT			_("Unrecognized(Eject OK)")
#define STR_IDE					_("IDE Card")
#define STR_LAN					_("LAN Card")
#define STR_OTHER				_("Other Card")
#define STR_YES					_("Yes")
#define STR_NO					_("No")
#define STR_OK					_("OK")

#define	MSG_MOUNT				_("Mounted")
#define	MSG_NOMOUNT				_("Unmounted")
#define	MSG_RW					_("Read/Write OK")
#define	MSG_RONLY				_("Read Only")
#define	MSG_DONE				_("Execute is Done.")
#define	MSG_NOTDO				_("Unexecuted.")
#define	MSG_NOTDO_MOUNTED		_("Unexecuted.\n Because Mounted.")
#define	MSG_NOTDO_USED			_("Unexecuted.\n Because Useing Now.")
#define	MSG_NOTDO_NOCARD		_("Unexecuted. Because No Card.\nor Unrecognized.")
#define	MSG_NOTDO_NOIDE			_("Unexecuted.\n Because No IDE Card.")
#define	MSG_UMOUNT				_("Mounted Now.\nGet Unmount at onetime?")
#define	MSG_LOSTMOUNT			_("Unexecuted.\n Because Mount fail.")
#define	MSG_LOSTUMOUNT			_("Unexecuted.\nUnmount fail.")
#define	MSG_NOERR				_("No error.")
#define	MSG_FINDERR				_("Error Detected.")
#define	MSG_DIFFERFS			_("Unsupported\nFile system.")
#define	MSG_DOSTOP				_("Execution abort.")
#define	MSG_FMTSTART			_("Start Format.")

#define TITLE_TOP				_("Floppy & PC Card Management Tool")
#define	TITLE_AFSRESTAT			_("A.M. Restart")
#define	TITLE_PCCSTART			_("Start")
#define	TITLE_PCCSTOP			_("Stop")
#define TITLE_TOOL				_("Tool")
#define	TITLE_FSCK				_("fsck")
#define	TITLE_FMT				_("format")

/*
	ޥɼ¹ԴϢ
*/
#define NAME_EXEC_STDOUT		"/tmp/.pctool/.pctool.out"
#define NAME_EXEC_STDERR		"/tmp/.pctool/.pctool.err"
#define NAME_DEVICE_FDD			"/dev/sda"
#define	STR_FMTDRIVE			"c:"
#define	STR_MPFDD				"/tmp/mp/fd"
#define	STR_MPS0				"/home/user/ide0"
#define	STR_MPS1				"/home/user/ide1"

#define EXEOUT					0
#define EXEERR					1
#define R						0
#define W						1
#define ICON_FDD				0
#define ICON_PCC0				1
#define ICON_PCC1				2
#define FUNC_IDE				4
#define FUNC_LAN				6
#define FUNC_OTHER				1000
#define FUNC_NONE				1001
#define FUNC_NOCARD				1002
#define SOCKET0					0
#define SOCKET1					1

/* ޥ */
#define	CMDSUDO					"/usr/local/bin/sudo"
#define	CMDMOUNT				"/bin/mount"
#define	CMDUMOUNT				"/bin/umount"
#define	CMDCARDCTL				"/sbin/cardctl"
#define	CMDKILL					"/bin/kill"
#define	CMDAUTOMOUNT			"/usr/sbin/automount"
#define	PCTOOLFDISK				"/usr/local/bin/pctool_fdisk"
#define	STR_AFSMP				"/tmp/mp"
#define	STR_AFSINI				"/etc/autofs.ini"
#define	STR_AFSCNT				"1"
#define	CMDPS					"/bin/ps"
#define	CMDCAT					"/bin/cat"
#define	CMDSLEEP				"/bin/sleep"
#define	CMDFSCK					"/sbin/dosfsck"
#define	CMDFDFORMAT				"/usr/local/bin/mformat"
#define	CMDMKFS					"/sbin/mkdosfs"
#define	CMDSH					"/bin/sh"

/*ێб*/
#define STR_ENV				"LANG"
#define STR_PCTOOLHELP		"/usr/local/bin/pctoolHelp"
#define STR_HELP_TOP		"/usr/local/share/pctool/Help/pctool_top.htm"
#define STR_HELP_TOOL		"/usr/local/share/pctool/Help/pctool_tool.htm"
/*ܸ*/
#define STR_LOCALEJA		"ja_JP.eucJP"
#define STR_HELP_TOPJA		"/usr/local/share/pctool/Help/pctool_top_ja.htm"
#define STR_HELP_TOOLJA		"/usr/local/share/pctool/Help/pctool_tool_ja.htm"

/*ŵưб*/
/*#define STR_START_NN		"/usr/lib/netscape/netscape-navigator"*/
#define STR_START_NN		"/usr/lib/netscape/start"

/*
	ư
*/
#define NUM_TOP_WIDTH			512
#define NUM_TOP_HEIGHT			416
#define NAME_TOP_FIX			"TopFix"

/*  */
#define NUM_TOP_XMP_WIDTH		32
#define NUM_TOP_XMP_HEIGHT		32
#define NUM_TOP_XMPFDD_X		8
#define NUM_TOP_XMPFDD_Y		8
#define NUM_TOP_XMPPCC0_X		272
#define NUM_TOP_XMPPCC0_Y		0
#define NUM_TOP_XMPPCC1_X		448
#define NUM_TOP_XMPPCC1_Y		0

/* 롼(˥塼) */
#define NAME_TOP_FRAMENU		"TopFraMenu"
#define NAME_TOP_FIXMENU		"TopFixMenu"
#define NAME_TOP_BTNMENUHELP	"TopBtnMenuHelp"
#define NUM_TOP_FRAMENU_WIDTH	496
#define NUM_TOP_FRAMENU_HEIGHT	32
#define NUM_TOP_FRAMENU_X		8
#define NUM_TOP_FRAMENU_Y		8
#define NUM_TOP_BTNMENUHELP_X	424
#define NUM_TOP_BTNMENUHELP_Y	0

/* 롼(Fdd) */
#define NAME_TOP_FRAFDD			"TopFraFdd"
#define NAME_TOP_FIXFDD			"TopFixFdd"
#define NAME_TOP_BTNFDD_STAT	"TopBtnFddStat"
#define NAME_TOP_BTNFDD_AFS		"TopBtnFddAfs"
#define NAME_TOP_LBLFDD_STAT	"TopLblFddStat"
#define NAME_TOP_LBLFDD_MP		"TopLblFddMp"
#define NAME_TOP_LBLFDD_MODE	"TopLblFddMode"
#define NAME_TOP_ETYFDD_STAT	"TopEtyFddStat"
#define NAME_TOP_ETYFDD_MP		"TopEtyFddMp"
#define NAME_TOP_ETYFDD_MODE	"TopEtyFddMode"

#define NUM_TOP_FRAFDD_WIDTH	352
#define NUM_TOP_FRAFDD_HEIGHT	136
#define NUM_TOP_FRAFDD_X		8
#define NUM_TOP_FRAFDD_Y		40
#define NUM_TOP_BTNFDDSTAT_X	168
#define NUM_TOP_BTNFDDSTAT_Y	88
#define NUM_TOP_BTNFDDAFS_X		240
#define NUM_TOP_BTNFDDAFS_Y		88
#define NUM_BTN_AFS_WIDTH		92
#define NUM_BTN_AFS_HEIGHT		24
#define NUM_TOP_LBLFDDSTAT_X	48
#define NUM_TOP_LBLFDDSTAT_Y	8
#define NUM_TOP_LBLFDDMP_X		48
#define NUM_TOP_LBLFDDMP_Y		32
#define NUM_TOP_LBLFDDMODE_X	48
#define NUM_TOP_LBLFDDMODE_Y	56
#define NUM_TOP_ETYFDDSTAT_X	168
#define NUM_TOP_ETYFDDSTAT_Y	8
#define NUM_TOP_ETYFDDMP_X		168
#define NUM_TOP_ETYFDDMP_Y		32
#define NUM_TOP_ETYFDDMODE_X	168
#define NUM_TOP_ETYFDDMODE_Y	56

/* 롼(Pcc) */
#define NAME_TOP_FRAPCC			"TopFraPcc"
#define NAME_TOP_FIXPCC			"TopFixPcc"
#define NAME_TOP_BTNPCC_START	"TopBtnPccStart"
#define NAME_TOP_BTNPCC_STOP	"TopBtnPccStop"
#define NAME_TOP_LBLPCC_STAT	"TopLblPccStat"
#define NAME_TOP_LBLPCC_KIND	"TopLblPccKind"
#define NAME_TOP_LBLPCC_MP		"TopLblPccMp"
#define NAME_TOP_LBLPCC_MODE	"TopLblPccMode"
#define NAME_TOP_ETYPCC_STAT0	"TopEtyPccStat0"
#define NAME_TOP_ETYPCC_KIND0	"TopEtyPccKind0"
#define NAME_TOP_ETYPCC_MP0		"TopEtyPccMp0"
#define NAME_TOP_ETYPCC_MODE0	"TopEtyPccMode0"
#define NAME_TOP_ETYPCC_STAT1	"TopEtyPccStat1"
#define NAME_TOP_ETYPCC_KIND1	"TopEtyPccKind1"
#define NAME_TOP_ETYPCC_MP1		"TopEtyPccMp1"
#define NAME_TOP_ETYPCC_MODE1	"TopEtyPccMode1"
#define NAME_TOP_RBTNPCC_S0		"TopRbtnPccS0"
#define NAME_TOP_RBTNPCC_S1		"TopRbtnPccS1"

#define NUM_TOP_FRAPCC_WIDTH	496
#define NUM_TOP_FRAPCC_HEIGHT	184
#define NUM_TOP_FRAPCC_X		8
#define NUM_TOP_FRAPCC_Y		184
#define NUM_TOP_BTNPCCSTART_X	336
#define NUM_TOP_BTNPCCSTART_Y	136
#define NUM_TOP_BTNPCCEND_X		408
#define NUM_TOP_BTNPCCEND_Y		136
#define NUM_TOP_LBLPCCSTAT_X	16
#define NUM_TOP_LBLPCCSTAT_Y	32
#define NUM_TOP_LBLPCCKIND_X	16
#define NUM_TOP_LBLPCCKIND_Y	56
#define NUM_TOP_LBLPCCMP_X		16
#define NUM_TOP_LBLPCCMP_Y		80
#define NUM_TOP_LBLPCCMODE_X	16
#define NUM_TOP_LBLPCCMODE_Y	104
#define NUM_TOP_ETYPCCSTAT0_X	136
#define NUM_TOP_ETYPCCSTAT0_Y	32
#define NUM_TOP_ETYPCCKIND0_X	136
#define NUM_TOP_ETYPCCKIND0_Y	56
#define NUM_TOP_ETYPCCMP0_X		136
#define NUM_TOP_ETYPCCMP0_Y		80
#define NUM_TOP_ETYPCCMODE0_X	136
#define NUM_TOP_ETYPCCMODE0_Y	104
#define NUM_TOP_ETYPCCSTAT1_X	312
#define NUM_TOP_ETYPCCSTAT1_Y	32
#define NUM_TOP_ETYPCCKIND1_X	312
#define NUM_TOP_ETYPCCKIND1_Y	56
#define NUM_TOP_ETYPCCMP1_X		312
#define NUM_TOP_ETYPCCMP1_Y		80
#define NUM_TOP_ETYPCCMODE1_X	312
#define NUM_TOP_ETYPCCMODE1_Y	104
#define NUM_TOP_RBTNPCCS0_X		136
#define NUM_TOP_RBTNPCCS0_Y		8
#define NUM_TOP_RBTNPCCS1_X		312
#define NUM_TOP_RBTNPCCS1_Y		8

/* ѳϥܥ */
#define	FILE_STAB				"/tmp/pcmcia/stab"
#define	NUM_TIMEOUT				10 - 1

/* 롼(ġС) */
#define NAME_TOP_FRATB			"TopFraToolbar"
#define NAME_TOP_FIXTB			"TopFixToolbar"
#define NAME_TOP_BTNTB_TOOL		"TopBtnToolbarTool"
#define NAME_TOP_BTNTB_END		"TopBtnToolbarEnd"
#define NUM_TOP_FRATB_WIDTH		496
#define NUM_TOP_FRATB_HEIGHT	40
#define NUM_TOP_FRATB_X			8
#define NUM_TOP_FRATB_Y			376
#define NUM_TOP_BTNTBTOOL_X		368
#define NUM_TOP_BTNTBTOOL_Y		0
#define NUM_TOP_BTNTBEND_X		432
#define NUM_TOP_BTNTBEND_Y		0

/*
	ġ
*/
#define NUM_TOOL_WIDTH			248
#define NUM_TOOL_HEIGHT			232

#define NAME_TOOL_FIX			"ToolFix"

/* 롼(˥塼) */
#define NAME_TOOL_FRAMENU		"ToolFraMenu"
#define NAME_TOOL_FIXMENU		"ToolFixMenu"
#define NAME_TOOL_BTNMENUHELP	"ToolBtnMenuHelp"
#define NUM_TOOL_FRAMENU_WIDTH	232
#define NUM_TOOL_FRAMENU_HEIGHT	32
#define NUM_TOOL_FRAMENU_X		8
#define NUM_TOOL_FRAMENU_Y		8
#define NUM_TOOL_BTNMENUHELP_X	160
#define NUM_TOOL_BTNMENUHELP_Y	0

/* 롼(¹) */
#define NAME_TOOL_FRATEXE		"ToolFraTExe"
#define NAME_TOOL_FIXTEXE		"ToolFixTExe"
#define NAME_TOOL_BTNTEXE_FCK	"ToolBtnTExeFck"
#define NAME_TOOL_BTNTEXE_FMT	"ToolBtnTExeFmt"
#define NUM_TOOL_FRATEXE_WIDTH	232
#define NUM_TOOL_FRATEXE_HEIGHT	144
#define NUM_TOOL_FRATEXE_X		8
#define NUM_TOOL_FRATEXE_Y		40
#define NUM_TOOL_BTNTEXEFCK_X	80
#define NUM_TOOL_BTNTEXEFCK_Y	88
#define NUM_TOOL_BTNTEXEFMT_X	152
#define NUM_TOOL_BTNTEXEFMT_Y	88

/* 롼(ġС) */
#define NAME_TOOL_FRATB			"ToolFraToolbar"
#define NAME_TOOL_FIXTB			"ToolFixToolbar"
#define NAME_TOOL_BTNTB_RETURN	"ToolBtnToolbarTool"
#define NAME_TOP_RBTNTFDD		"TopRbtnTFdd"
#define NAME_TOP_RBTNTPCC_S0	"TopRbtnTPccS0"
#define NAME_TOP_RBTNTPCC_S1	"TopRbtnTPccS1"

#define NUM_TOOL_FRATB_WIDTH	232
#define NUM_TOOL_FRATB_HEIGHT	40
#define NUM_TOOL_FRATB_X		8
#define NUM_TOOL_FRATB_Y		192
#define NUM_TOOL_BTNTBRETURN_X	168
#define NUM_TOOL_BTNTBRETURN_Y	0
#define NUM_TOP_RBTNTFDD_X		16
#define NUM_TOP_RBTNTFDD_Y		0
#define NUM_TOP_RBTNTPCCS0_X	16
#define NUM_TOP_RBTNTPCCS0_Y	24
#define NUM_TOP_RBTNTPCCS1_X	16
#define NUM_TOP_RBTNTPCCS1_Y	48

/*
	å
*/

#define NUM_MSG_WIDTH			256
#define NUM_MSG_HEIGHT			96
#define NUM_MSG_BTN_Y			56
#define NUM_MSG_BTN1_X			112
#define NUM_MSG_BTN2_X			184
#define NUM_LBL_WIDTH			208
#define NUM_LBL_HEIGHT			16
#define NUM_LBL_X				24
#define NUM_LBL_Y				24
