#include <gtk/gtk.h>
#include "common.h"
#include "wintool.h"
#include "cb_wintool.h"

static GtkWidget	*window;
static int			ToolSelect;

void
CreateWintool()
{

	ToolSelect = 0;
	/* ١ɥ */
	CreateTBase();

	/* 롼(˥塼) */
	CreateTMenu();

	/* 롼(¹) */
	CreateTExe();

	/* 롼(ġС) */
	CreateTToolBar();

	/* ġɽ */
	gtk_widget_show( window );

	return;
}

/*
	١ɥ
*/
static void
CreateTBase()
{
	GtkWidget	*fixToolBase;

	window = gtk_window_new( GTK_WINDOW_TOPLEVEL );
	gtk_window_set_modal( GTK_WINDOW( window ),
						  TRUE );
	gtk_window_set_title( GTK_WINDOW( window ),
						  TITLE_TOOL );
	gtk_widget_set_usize( window,
						  NUM_TOOL_WIDTH,
						  NUM_TOOL_HEIGHT );
	gtk_window_set_position( GTK_WINDOW( window ),
							 GTK_WIN_POS_CENTER );
	gtk_window_set_policy( GTK_WINDOW( window ),
						   FALSE,
						   FALSE,
						   FALSE );

	/* fixed box */
	fixToolBase = CreateFixed( window,
							   NAME_TOOL_FIX );
	gtk_container_add( GTK_CONTAINER( window ),
					   fixToolBase );

	return;
}

/*
	롼(˥塼)
*/
static void
CreateTMenu()
{
	GtkWidget	*fraMenu;
	GtkWidget	*fixMenu;
	GtkWidget	*btnMenuHelp;
	Scale		sca;
	Position	pos;


	/* frame */
	sca.width  = NUM_TOOL_FRAMENU_WIDTH;
	sca.height = NUM_TOOL_FRAMENU_HEIGHT;
	pos.x      = NUM_TOOL_FRAMENU_X;
	pos.y      = NUM_TOOL_FRAMENU_Y;
	fraMenu = CreateFrame( window,
						   NAME_TOOL_FRAMENU,
						   NULL,
						   &sca,&pos,
						   GTK_SHADOW_NONE );
	gtk_fixed_put( GTK_FIXED( GET_OBJECT( window,NAME_TOOL_FIX ) ),
										  fraMenu,
										  pos.x,pos.y );

	/* fixMenu */
	fixMenu = CreateFixed( window,
						   NAME_TOOL_FIXMENU );
	gtk_container_add( GTK_CONTAINER( fraMenu ),
					   fixMenu );

	/* btnMenuHelp */
	sca.width  = NUM_BTN_BASIC_WIDTH;
	sca.height = NUM_BTN_BASIC_HEIGHT;
	pos.x      = NUM_TOOL_BTNMENUHELP_X;
	pos.y      = NUM_TOOL_BTNMENUHELP_Y;
	btnMenuHelp = CreateButton( window,
								NAME_TOOL_BTNMENUHELP,
								STR_HELP,
								&sca,&pos,
								TRUE );
	gtk_fixed_put( GTK_FIXED( fixMenu ),
				   btnMenuHelp,
				   pos.x,pos.y );

	/* signal³ */
	gtk_signal_connect( GTK_OBJECT( btnMenuHelp ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnTMenuHelp_Clicked ),
						NULL );

	return;
}


/*
	롼(¹)
*/
static void
CreateTExe()
{
	GtkWidget	*fraTExe;
	GtkWidget	*fixTExe;
	GtkWidget	*btnTExeFck;
	GtkWidget	*btnTExeFmt;
	GSList		*rbtnGroup = NULL;
	GtkWidget	*rbtnTFdd;
	GtkWidget	*rbtnTPccS0;
	GtkWidget	*rbtnTPccS1;
	Scale		sca;
	Position	pos;
	int i;


	/* fraTB */
	sca.width  = NUM_TOOL_FRATEXE_WIDTH;
	sca.height = NUM_TOOL_FRATEXE_HEIGHT;
	pos.x      = NUM_TOOL_FRATEXE_X;
	pos.y      = NUM_TOOL_FRATEXE_Y;

	fraTExe = CreateFrame( window,
						 NAME_TOOL_FRATEXE,
						 STR_EXE,
						 &sca,&pos,
						 GTK_SHADOW_ETCHED_IN );
	gtk_fixed_put( GTK_FIXED( GET_OBJECT( window,NAME_TOOL_FIX ) ),
										  fraTExe,
										  pos.x,pos.y );

	/* fixTB */
	fixTExe = CreateFixed( window,
						 NAME_TOOL_FIXTEXE );
	gtk_container_add( GTK_CONTAINER( fraTExe ),
					   fixTExe );
	
	/* btnTExeFck */
	sca.width  = NUM_BTN_BASIC_WIDTH;
	sca.height = NUM_BTN_BASIC_HEIGHT;
	pos.x      = NUM_TOOL_BTNTEXEFCK_X;
	pos.y      = NUM_TOOL_BTNTEXEFCK_Y;
	btnTExeFck = CreateButton( window,
							   NAME_TOOL_BTNTEXE_FCK,
							   STR_FCK,
							   &sca,&pos,
							   TRUE );
	gtk_fixed_put( GTK_FIXED( fixTExe ),
				   btnTExeFck,
				   pos.x,pos.y );

	/*signal*/
	gtk_signal_connect( GTK_OBJECT( btnTExeFck ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnTExeFck_Clicked ),
						NULL );


	/* btnTExeFmt */
	sca.width  = NUM_BTN_BASIC_WIDTH;
	sca.height = NUM_BTN_BASIC_HEIGHT;
	pos.x      = NUM_TOOL_BTNTEXEFMT_X;
	pos.y      = NUM_TOOL_BTNTEXEFMT_Y;
	btnTExeFmt = CreateButton( window,
							   NAME_TOOL_BTNTEXE_FMT,
							   STR_FMT,
							   &sca,&pos,
							   TRUE );
	gtk_fixed_put( GTK_FIXED( fixTExe ),
				   btnTExeFmt,
				   pos.x,pos.y );

	/*signal*/
	gtk_signal_connect( GTK_OBJECT( btnTExeFmt ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnTExeFmt_Clicked ),
						NULL );

	/* radio button  */
	sca.width  = NUM_RBTN_WIDE_WIDTH;
	sca.height = NUM_RBTN_WIDE_HEIGHT;
	pos.x      = NUM_TOP_RBTNTFDD_X;
	pos.y      = NUM_TOP_RBTNTFDD_Y;

	/* rbtnTFdd */
	rbtnTFdd  = gtk_radio_button_new_with_label( rbtnGroup,
												 STR_FLOPPY );
	rbtnGroup = gtk_radio_button_group( GTK_RADIO_BUTTON( rbtnTFdd ) );
	gtk_object_set_data( GTK_OBJECT( window ),
						 NAME_TOP_RBTNTFDD,
						 rbtnTFdd );
	gtk_widget_set_usize( rbtnTFdd,
						  sca.width,
						  sca.height );
	gtk_widget_set_uposition( rbtnTFdd,
							  pos.x,pos.y );
	gtk_widget_show( rbtnTFdd );
	gtk_fixed_put( GTK_FIXED( fixTExe ),
				   rbtnTFdd,
				   pos.x,pos.y );

	/* rbtnTPccS0 */
	pos.x = NUM_TOP_RBTNTPCCS0_X;
	pos.y = NUM_TOP_RBTNTPCCS0_Y;
	rbtnTPccS0 = gtk_radio_button_new_with_label( rbtnGroup,
												  STR_PCSOCKET0 );
	rbtnGroup = gtk_radio_button_group( GTK_RADIO_BUTTON( rbtnTPccS0 ) );
	gtk_object_set_data( GTK_OBJECT( window ),
						 NAME_TOP_RBTNTPCC_S0,
						 rbtnTPccS0 );
	gtk_widget_set_usize( rbtnTPccS0,
						  sca.width,
						  sca.height );
	gtk_widget_set_uposition( rbtnTPccS0,
							  pos.x,pos.y );
	gtk_widget_show( rbtnTPccS0 );
	gtk_fixed_put( GTK_FIXED( fixTExe ),
				   rbtnTPccS0,
				   pos.x,pos.y );

	/* rbtnTPccS1 */
	pos.x = NUM_TOP_RBTNTPCCS1_X;
	pos.y = NUM_TOP_RBTNTPCCS1_Y;
	rbtnTPccS1 = gtk_radio_button_new_with_label( rbtnGroup,
												  STR_PCSOCKET1 );
	rbtnGroup = gtk_radio_button_group( GTK_RADIO_BUTTON( rbtnTPccS1 ) );
	gtk_object_set_data( GTK_OBJECT( window ),
						 NAME_TOP_RBTNTPCC_S1,
						 rbtnTPccS1 );
	gtk_widget_set_usize( rbtnTPccS1,
						  sca.width,
						  sca.height );
	gtk_widget_set_uposition( rbtnTPccS1,
							  pos.x,pos.y );
	gtk_widget_show( rbtnTPccS1 );
	gtk_fixed_put( GTK_FIXED( fixTExe ),
				   rbtnTPccS1,
				   pos.x,pos.y );

	/*signal*/
	gtk_signal_connect( GTK_OBJECT( rbtnTFdd ),
						"pressed",
						GTK_SIGNAL_FUNC( On_rbtnTool_Pressed ),
						( gpointer )1 );
	gtk_signal_connect( GTK_OBJECT( rbtnTPccS0 ),
						"pressed",
						GTK_SIGNAL_FUNC( On_rbtnTool_Pressed ),
						( gpointer )2 );
	gtk_signal_connect( GTK_OBJECT( rbtnTPccS1 ),
						"pressed",
						GTK_SIGNAL_FUNC( On_rbtnTool_Pressed ),
						( gpointer )3 );

}

/*
	롼(ġС)
*/
static void
CreateTToolBar()
{
	GtkWidget	*fraTB;
	GtkWidget	*fixTB;
	GtkWidget	*btnTBReturn;
	Scale		sca;
	Position	pos;

	/* fraTB */
	sca.width  = NUM_TOOL_FRATB_WIDTH;
	sca.height = NUM_TOOL_FRATB_HEIGHT;
	pos.x      = NUM_TOOL_FRATB_X;
	pos.y      = NUM_TOOL_FRATB_Y;

	fraTB = CreateFrame( window,
						 NAME_TOOL_FRATB,
						 NULL,
						 &sca,&pos,
						 GTK_SHADOW_NONE );
	gtk_fixed_put( GTK_FIXED( GET_OBJECT( window,NAME_TOOL_FIX ) ),
										  fraTB,
										  pos.x,pos.y );

	/* fixTB */
	fixTB = CreateFixed( window,
						 NAME_TOOL_FIXTB );
	gtk_container_add( GTK_CONTAINER( fraTB ),
					   fixTB );
	
	/* btnTBReturn */
	sca.width  = NUM_BTN_WIDE_WIDTH;
	sca.height = NUM_BTN_WIDE_HEIGHT;
	pos.x      = NUM_TOOL_BTNTBRETURN_X;
	pos.y      = NUM_TOOL_BTNTBRETURN_Y;
	btnTBReturn = CreateButton( window,
							    NAME_TOOL_BTNTB_RETURN,
							    STR_RETURN,
							    &sca,&pos,
							    TRUE );
	gtk_fixed_put( GTK_FIXED( fixTB ),
				   btnTBReturn,
				   pos.x,pos.y );

	/* signal³ */
	gtk_signal_connect( GTK_OBJECT( btnTBReturn ),
						"clicked",
						GTK_SIGNAL_FUNC( On_btnTBReturn_Clicked ),
						NULL );

	return;
}
